package com.gic.haoban.manage.service.task;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.gic.commons.util.GICMQClientUtil;
import com.gic.haoban.manage.api.dto.DealParamMqDTO;
import com.gic.haoban.manage.api.enums.PreDealStatusEnum;
import com.gic.haoban.manage.api.enums.PreDealTypeEnum;
import com.gic.haoban.manage.api.enums.SyncTaskStatusEnum;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.service.entity.TabHaobanPreDealLog;
import com.gic.haoban.manage.service.entity.TabHaobanSyncTask;
import com.gic.haoban.manage.service.service.PreDealService;
import com.gic.haoban.manage.service.service.SyncTaskService;
import com.gic.mq.sdk.GicMQClient;
import com.gic.redis.data.util.RedisUtil;
import org.apache.commons.collections.CollectionUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

@Service
@Deprecated
public class FriendClerkSyncOperation implements BaseSyncOperation {

	private static final Logger logger = LoggerFactory.getLogger(FriendClerkSyncOperation.class);
	@Autowired
	private PreDealService preDealService;
	@Autowired
	private MemberUnionidRelatedApiService memberUnionidRelatedApiService;
	@Autowired
	private SyncTaskService syncTaskService;
	
	@Override
	public void dealSingleByMq(DealParamMqDTO dealParamMqDTO, TabHaobanPreDealLog dataPre) {
		logger.info("dealParamMqDTO={},dataPre={}",JSON.toJSONString(dealParamMqDTO),JSON.toJSONString(dataPre));
		String reason = "";
		boolean dealFlag = true;
		String taskId = dealParamMqDTO.getTaskId();
		try {
			String wxEnterpriseId = dataPre.getWxEnterpriseId();
			String wxUserId = dataPre.getDataId();
			List<String> selfUserIdList = memberUnionidRelatedApiService.listSelfExterialList(wxEnterpriseId, wxUserId);
			logger.info("selfUserIdList={}",selfUserIdList.size());
			List<String> userIdList = memberUnionidRelatedApiService.listExterialList(wxEnterpriseId, wxUserId);
			if(CollectionUtils.isEmpty(userIdList) || CollectionUtils.isEmpty(selfUserIdList)){
				return;
			}
			memberUnionidRelatedApiService.cleanNoExsitFriend(wxEnterpriseId, wxUserId,JSON.toJSONString(userIdList));
			logger.info("userIdList={}",userIdList.size());
			if(CollectionUtils.isNotEmpty(selfUserIdList)){
				List<TabHaobanPreDealLog> dealLogList = selfUserIdList.stream().map(externalUserId -> {
		            TabHaobanPreDealLog dealLog = new TabHaobanPreDealLog();
		            dealLog.setDataId(externalUserId +"-"+ wxUserId);
		            dealLog.setpDataId(dataPre.getDataId());
		            dealLog.setDataType(PreDealTypeEnum.self_friend.getVal());
		            dealLog.setStatusFlag(0);
		            dealLog.setTaskId(dataPre.getTaskId());
		            dealLog.setDataContent(externalUserId);
		            dealLog.setWxEnterpriseId(wxEnterpriseId);
		            return dealLog;
		        }).collect(Collectors.toList());

		        preDealService.insert(dealLogList);
		        HashSet<String> hashSet = (HashSet<String>) dealLogList.stream().map(TabHaobanPreDealLog::getDataId).collect(Collectors.toSet());
		        dealDepartmentToMq(dataPre.getTaskId(), hashSet, SyncTaskStatusEnum.self_friend_sync);
			}
			
			if(CollectionUtils.isNotEmpty(userIdList)){
				List<TabHaobanPreDealLog> dealLogList = userIdList.stream().map(externalUserId -> {
		            TabHaobanPreDealLog dealLog = new TabHaobanPreDealLog();
		            dealLog.setDataId(externalUserId +"-"+ wxUserId);
		            dealLog.setpDataId(dataPre.getDataId());
		            dealLog.setDataType(PreDealTypeEnum.friend.getVal());
		            dealLog.setStatusFlag(0);
		            dealLog.setTaskId(dataPre.getTaskId());
		            dealLog.setDataContent(externalUserId);
		            dealLog.setWxEnterpriseId(wxEnterpriseId);
		            return dealLog;
		        }).collect(Collectors.toList());

		        preDealService.insert(dealLogList);
		        HashSet<String> hashSet = (HashSet<String>) dealLogList.stream().map(TabHaobanPreDealLog::getDataId).collect(Collectors.toSet());
		        dealDepartmentToMq(dataPre.getTaskId(), hashSet, SyncTaskStatusEnum.friend_sync);
			}
		} catch (Exception e) {
			e.printStackTrace();
            logger.info("同步失败：{},{}", JSONObject.toJSONString(dataPre),e);
            reason = "成员好友处理异常";
            dealFlag = false;
		}finally {
			if (!dealFlag) {
                dealException(dealParamMqDTO.getTaskId(), dealParamMqDTO.getData(), dataPre.getEnterpriseId(), reason);
            } else {
                dealSuccess(dealParamMqDTO.getTaskId(), dealParamMqDTO.getData(), dataPre.getEnterpriseId(), dataPre.getWxEnterpriseId());
            }
//			checkDepartmentTask(taskId);
		}
	}

	@Override
	public void dealException(String taskId, String dataId, String enterpriseId, String reason) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.exception.getVal(), reason);

	}

	@Override
	public void dealSuccess(String taskId, String dataId, String enterpriseId, String wxEnterpriseId) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.computed.getVal(), "成功");

	}

	@Override
	public void checkDepartmentTask(String taskId) {
		String key = "sync_wx_lock_";
		boolean b = preDealService.checkTask(taskId, PreDealTypeEnum.friend_clerk.getVal());
        if (!b) {
            return;
        }
        logger.info("好友同步成功:{}", taskId);
        TabHaobanSyncTask syncTask = syncTaskService.getSyncTask(taskId);
        //同步成功 进入门店处理
    	syncTaskService.updateTaskStatus(taskId, SyncTaskStatusEnum.compute.getVal());
    	RedisUtil.delCache(key + syncTask.getWxEnterpriseId());

	}
	
	
	/**
     * 放入mq处理部门数据
     *
     * @param taskId
     * @param dealList
     */
    private void dealDepartmentToMq(String taskId, Set<String> dealList, SyncTaskStatusEnum syncTaskStatusEnum) {
        //预处理分组任务
        syncTaskService.updateTaskStatus(taskId, syncTaskStatusEnum.getVal());
        dealList.forEach(relationId -> {
            DealParamMqDTO dealParamMqDTO = new DealParamMqDTO();
            dealParamMqDTO.setTaskId(taskId);
            dealParamMqDTO.setData(relationId);
            dealParamMqDTO.setType(syncTaskStatusEnum.getVal());
            GicMQClient clientInstance = GICMQClientUtil.getClientInstance();
            try {
                clientInstance.sendMessage("departmentSyncDealMq", JSONObject.toJSONString(dealParamMqDTO));
            } catch (Exception e) {
                logger.info("发送失败:{},{}", taskId, relationId);
                e.printStackTrace();
            }
        });
    }

}
